#include <qtooltip.h>
#include <qstring.h>
#include <qlineedit.h>
#include <qwidget.h>
#include "OmSourceLabelEdit.h"

#include "OmSourceEdit.h"
#include "OmSourceLabel.h"

#include <qfont.h>
#include <qfontinfo.h>
#include <qfontmetrics.h>
#include <iostream>



OmSourceLabelEdit::OmSourceLabelEdit(QWidget *parent, 

				     QString label, QString editLabel, 
       int x, int y, int height, QString help) :
      QWidget(parent), _labelName(label)
  //     _parent(parent), _labelName(label)
 

{



    // Position the edit widget so that its right edge is at position x
    
     cout << "Omsourcelabeldit constructor Input x=" << x << endl;  
    // Set up the edit box, right, top corner will be at x, y 
    QFontMetrics fm = fontMetrics();
 
    int editLabelWidth = fm.width(editLabel) + 5;
    int labelWidth = fm.width(label) + 5;
       
    int dx = 3;
   
    int width = editLabelWidth +  labelWidth + dx;
    setGeometry(parent->x() +  x - width, y, width, height);
    
    cout << "Parent geometry = x=" << parent->x() << " y=" << parent->y() << " width=" 
	 << parent->width() << " height=" << parent->height() << endl;   

    int xPos = x -  editLabelWidth;
    //    _edit = new OmSourceEdit(parent, editLabel, xPos, y, pixelWidth, height ); 
    _edit = new OmSourceEdit(parent, editLabel, xPos, y, editLabelWidth, height ); 
    cout << "Edit label = " << editLabel << " width+5=" << editLabelWidth << endl;      
   cout << "edit geometry=x=" << _edit->x() << " y=" << 
          _edit->y() << " width=" << _edit->width() << " height=" << _edit->height() << endl;


    // Set up the label to the left of the edit box 
   
    xPos = x - width;
 
    _label = new OmSourceLabel(parent, label, xPos, y, labelWidth, height);
    cout << "label label = " << label << " width+5=" << labelWidth << endl;      
    cout << help << endl;
    //    cout << "label geometry=x=" << _label->x() << " y=" << 
    //          _label->y() << " width=" << _label->width() << " height=" << _label->height() << endl;

    //    _label = new OmSourceLabel(parent, label, xPos, y, height);
    //    _label->move(_edit->x() - _label->width() - 3, y);
  
    //    setGeometry(_label->x(), y, _label->width() + _edit->width() + 3, height);
    //    cout << "Widget geometry=x=" << this->x() << " y=" << 
    //          this->y() << " width=" << this->width() << " height=" << this->height() << endl;

    if (help)   
        QToolTip::add(this, help);

};
/****************************************************
* Sets the text in the edit box
***************************************************/
void OmSourceLabelEdit::setText(const QString &text)
{
   
  //    QFontMetrics fm = this->fontMetrics();
   
    QFontMetrics fm = fontMetrics();
  

    int pixelWidth = fm.width(_labelName) + 5;
    int xPos = _edit->x() + _edit->width() - pixelWidth;
 
       
    _edit->setGeometry(xPos, _edit->y(), pixelWidth, _edit->height());

   _edit->setText(text);


    // Set up the label to the left of the edit box 
    pixelWidth = fm.width(_labelName) + 5;
    xPos -= (pixelWidth + 3);
    //    _label->setGeometry(xPos, _label->y(), _label->width(), _label->height());
    



}
 




