#ifndef OmSourceProcessDlg_h
#define OmSourceProcessDlg_h
#include <qapplication.h>

#include <qdialog.h>
#include <qstring.h>
#include <qcheckbox.h>
class QSpinBox;


#include "OmSourceLog.h"
#include "OmImageDisplay.h"
#include "OmSourceVersionNo.h"

F90MODPROCPROTO(void,omsource_glue, recompute)(const int& id);
F90MODPROCPROTO(void, omsource_glue, computephotometry)(OmSourceParameters &sources);
F90MODPROCPROTO(void, omsource_glue, computebackgroundimage)();


class QLabel;;
class ProcessDlg : public QDialog
{
    Q_OBJECT
     
 private slots:
    

    void runProcess1();    
    void pause1();  
    void runProcess2();    
    void pause2();  
    void runProcess3();    
    void pause3();  
  

      public:
    ProcessDlg(QWidget *parent, int no = 0, 
           QString text = QString::null, 
           void (*function)(int sourceNo) = 0);

     ProcessDlg(QWidget *parent, void (*function)());


   

    
    ProcessDlg(QWidget *parent, OmSourceParameters *source, 
           QString text = QString::null, 
           void (*function)(OmSourceParameters *source) = NULL);





 
    static void aperturePhotometry(int sourceNo)
    {

      //     cout << "omsourceprocessdlg.h aperturephotometry line 59\n";         
      //      cout << "Source no=" << sourceNo << endl;        
        F90MODPROC(omsource_glue, recompute)(sourceNo);
 

    }; 
    static void aperturePhotometry(OmSourceParameters *source)
    {


             
        F90MODPROC(omsource_glue, computephotometry)(*source);
    

    }; 

    static void computeBackgroundImage()
    {

         
        F90MODPROC(omsource_glue, computebackgroundimage)();
    

    }; 











    static void createNewSourceListFile(int no = 0);    
 private:
    int _sourceNo;
    OmSourceParameters *_source;
    QString _caption;
    QLabel *_label;
    void (*Function1)(int sourceNo);    
    void (*Function2)(OmSourceParameters *_source);    
    void (*Function3)();    

};

#endif



